import java.rmi.RemoteException;
import java.rmi.registry.LocateRegistry;
import java.rmi.registry.Registry;
import java.rmi.server.UnicastRemoteObject;
import java.util.ArrayList;
import java.util.List;

public class ServerAn implements MethosInterfaces {
	private List<Vehicle> carList = new ArrayList<Vehicle>(); 
	
	public ServerAn() {
		carList.add(new Vehicle("Matheus", 1000, "Camionete", "S10", 2008));
		carList.add(new Vehicle("Matheus", 1000, "Camionete", "S10", 2009));
		carList.add(new Vehicle("Matheus", 1000, "Camionete", "S10", 2010));
		carList.add(new Vehicle("Matheus", 1000, "Camionete", "S10", 2011));
		carList.add(new Vehicle("Matheus", 1000, "Carro pequeno", "UNO", 2008));
	}

	public static void main(String[] args) {
		try {
			ServerAn server = new ServerAn();
			MethosInterfaces stub = (MethosInterfaces) UnicastRemoteObject.exportObject(server, 0);
			Registry registry = LocateRegistry.getRegistry();
	        registry.bind("Server", stub);
			System.out.println("Servider running");
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}

	@Override
	public List<Vehicle> search(String field, String value) throws RemoteException {
		field = field.toLowerCase();
		List<Vehicle> listReturn = new ArrayList<Vehicle>();
		System.out.println("Searching for: " + field + " by " + value);
		if (field.equals("seller")) { 
			for (int i=0; i < carList.size(); i++) {
				Vehicle v = carList.get(i);
				if(v.getSeller().contains(value))
					listReturn.add(v);
			}
		} else if(field.equals("price")) { 
			for (int i=0; i < carList.size(); i++) {
				Vehicle v = carList.get(i);
				if(v.getPrice() < Float.parseFloat(value))
					listReturn.add(v);
			}
		} else if(field.equals("type")) { 
			for (int i=0; i < carList.size(); i++) {
				Vehicle v = carList.get(i);
				if(v.getType().equals(value))
					listReturn.add(v);
			}
		} else if(field.equals("model")) { 
			for (int i=0; i < carList.size(); i++) {
				Vehicle v = carList.get(i);
				if(v.getModel().equals(value))
					listReturn.add(v);
			}
		} else if(field.equals("year")) { 
			for (int i=0; i < carList.size(); i++) {
				Vehicle v = carList.get(i);
				if(v.getYear() == Integer.parseInt(value))
					listReturn.add(v);
			}
		}
		System.out.println(listReturn);	 
		return listReturn;
	}

	@Override
	public void add(Vehicle v) throws RemoteException {
		carList.add(v);
	}

}
